
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class Main
{

    public Main() throws IOException
    {

    }

    private void solve() throws IOException
    {
        String s = next();
        int n = s.length();
        char c[] = new char[4 * n];
        int sz = 0;
        for (int i = 0; i < s.length(); i++)
        {
            c[sz++] = s.charAt(i);
            c[sz++] = '#';
        }
        for (int i = 0; i < s.length(); i++)
        {
            c[sz++] = s.charAt(i);
            c[sz++] = '#';
        }
        int d[] = new int[sz];
        int l = 0, r = 0;
        int ans = 0;
        for (int i = 0; i < sz; i++)
        {
            if (i < r)
            {
                d[i] = Math.min(d[l + r - i - 1], r - i - 1);
            }
            while (i + d[i] < sz && i - d[i] >= 0 && c[i - d[i]] == c[i + d[i]])
            {
                d[i]++;
            }
            d[i]--;
            if (i + d[i] + 1 > r)
            {
                l = i - d[i];
                r = i + d[i] + 1;
            }
            if (c[i] != '#')
            {
                int len = (d[i] / 2) * 2 + 1;
                if (len > n)
                {
                    len -= ((len - n + 1) / 2) * 2;
                }
                ans = Math.max(ans, len);
            }
            else
            {
                int len = (d[i] / 2) * 2;
                if (len > n)
                {
                    len -= ((len - n + 1) / 2) * 2;
                }
                ans = Math.max(ans, len);
            }
        }
        out.println(ans);
    }

    void sort(int a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            int t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    public static void main(String[] args) throws IOException
    {
        new Main().run();
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);
    String next() throws IOException
    {
        while (st == null || !st.hasMoreTokens())
        {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException
    {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException
    {
        return Long.parseLong(next());
    }

    private void run() throws IOException
    {
        solve();
        out.close();
    }

}