#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    string s;
    cin >> s;
    int n = (int) s.length();
    s = s + s;

    int best = 0;
    for (int i = 0; i < s.length(); i++) {
        int i1 = i, i2 = i;
        while (i1 >= 0 && i2 < s.length() && s[i1] == s[i2]) {
            if (i2 - i1 + 1 > n) {
                break;
            }
            best = max(best, i2 - i1 + 1);
            i1--;
            i2++;
        }

        i1 = i;
        i2 = i + 1;
        while (i1 >= 0 && i2 < s.length() && s[i1] == s[i2]) {
            if (i2 - i1 + 1 > n) {
                break;
            }
            best = max(best, i2 - i1 + 1);
            i1--;
            i2++;
        }
    }

    cout << best << endl;

    return 0;
}
